
#define PAR     ( *( volatile unsigned int  * ) -0x1F0 )
#define CNT     ( *( volatile unsigned int  * ) -0x1F1 )
#define INA     ( *( volatile unsigned int  * ) -0x1F2 )
#define INB     ( *( volatile unsigned int  * ) -0x1F3 )
#define OUTA    ( *( volatile unsigned int  * ) -0x1F4 )
#define OUTB    ( *( volatile unsigned int  * ) -0x1F5 )
#define DIRA    ( *( volatile unsigned int  * ) -0x1F6 )
#define DIRB    ( *( volatile unsigned int  * ) -0x1F7 )
#define CTRA    ( *( volatile unsigned int  * ) -0x1F8 )
#define CTRB    ( *( volatile unsigned int  * ) -0x1F9 )
#define FRQA    ( *( volatile unsigned int  * ) -0x1FA )
#define FRQB    ( *( volatile unsigned int  * ) -0x1FB )
#define PHSA    ( *( volatile unsigned int  * ) -0x1FC )
#define PHSB    ( *( volatile unsigned int  * ) -0x1FD )
#define VCFG    ( *( volatile unsigned int  * ) -0x1FE )
#define VSCL    ( *( volatile unsigned int  * ) -0x1FF )

#define CLKFREQ ( *( volatile unsigned int  * ) -0x200 )
#define CLKMODE ( *( volatile unsigned char * ) -0x201 )
#define CHIPVER ( *( volatile unsigned char * ) -0x202 )
#define RXPIN     31
#define TXPIN     30
#define BAUD    9600
#define INVERT  0
 
 
extern RxByte( unsigned int pinNumber, int baudRate); 
extern TxText( unsigned int pinNumber, int baudRate, char * strPtr );
extern TxByte( unsigned int pinNumber, int baudRate, unsigned char dataByte );
extern WaitCnt( unsigned int cntMatch );

unsigned char  cx ;
char kb[64];      //Keyboard Buffer, PAD with 1 long for now   
int z,j;          //Keyboard Buffer Pointers (not the best name for pointers)

void getcx(); 

void keyin();

void main()              // test  loop using  
{
	 j=0;
     z=0;
	 tvText_start(12);                // Hippy how does one handle this SPIN file link
	cognew(keyin,&stack[18]);      // not sure how you would handle this
   	 while(1)
	 {		 
	 getcx();
	 if (cx!=0x0)
	     {
		 tvText_out(cx);
         }
     }
}



void getcx()     // unload keyboard buffer and decode arrow key for my tiny Prop WP
{
if(j!=z)                                       //is buffer empty ??   'z' is input pointer in Keyin
	 {
	 j++;
 	 if (j>=60){j=0;}                          //rewind buffer 'j' output pointer
			cx =kb[j];                         // get next char in buffer
			  if (cx==0x1b)                    //look for arrow key sequence
			      {
				  j++;
				  if (j>=60){j=0;}   
				  waitcnt(CLKFREQ/200 + CNT);  //don't check too early 
		       	  if (kb[j]== 0x5b )           //check next key in sequence
	              		{
						j++;
						if (j>=60){j=0;}   
				        cx= 0x80 + kb[j];      //found it, now modify for my tvText_out
						return;                //return with arrow code 
				        }
					cx=0x0;	                   //not decoded hook for other sequences
					return;
				  } 		
			return;                           //normal return	    
     }
	cx=0x0;	                                  //buffer empty
	return; 	 
}


void keyin()            // buffer RxByte required to trap ESC keyboard Sequences (repeated arrow keys) 
{
  while (1)
  {                     cx = RxByte(RXPIN,BAUD) ;
                     	if (cx!=0x00)
                        { z++;	
 	                      if (z>=60){z=0;}              // rewind pointer
	                      kb[z]=cx;  
                        }   	
          
                    
  }
}
